package cn.com.qmth.examcloud.core.oe.student.face.service;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamCaptureQueueEntity;
import cn.com.qmth.examcloud.core.oe.common.enums.ExamCaptureQueueStatus;
import cn.com.qmth.examcloud.core.oe.student.face.service.bean.SaveExamCaptureQueueInfo;

/**
 * @author chenken
 * @date 2018/8/17 14:45
 * @company QMTH
 * @description 抓拍队列服务接口
 */
public interface ExamCaptureQueueService {

    /**
     * 保存考试抓拍照片队列
     * @param examRecordDataId
     * @param baseFaceToken
     * @param fileUrl
     * @param fileName
     */
    String saveExamCaptureQueue(SaveExamCaptureQueueInfo saveExamCaptureQueueInfo, Long studentId);
    /**
     * 处理照片队列
     */
    void processingExamCaptureQueue();

    /**
     * 将超过XX分钟，还在处理中的状态修改为未处理
     */
    void changeExamCaptureQueueStatus();
    
    /**
     * 处理失败时,保存队列信息
     * @param examCaptureQueueEntity
     * @param errorMsg
     */
    void saveExamCaptureQueueEntityByFailed(ExamCaptureQueueEntity examCaptureQueueEntity,
                                            String errorMsg, ExamCaptureQueueStatus examCaptureQueueStatus);

}
