package cn.com.qmth.examcloud.core.oe.student.face.starter.config;

import java.util.concurrent.Executor;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;

@Configuration
@EnableAsync
public class TaskExecutorConfigure extends WebMvcConfigurerAdapter{

	 @Bean 
     public Executor getExecutor() {  
	      ThreadPoolTaskExecutor executor = new ThreadPoolTaskExecutor();  
	      executor.setCorePoolSize(30);//线程池创建时候初始化的线程数
	      executor.setMaxPoolSize(100);//线程池最大的线程数，只有在缓冲队列满了之后才会申请超过核心线程数的线程
	      executor.setQueueCapacity(250);//用来缓冲执行任务的队列
	      executor.setKeepAliveSeconds(10);//允许线程的空闲时间10秒：当超过了核心线程出之外的线程在空闲时间到达之后会被销毁
	      executor.setThreadNamePrefix("OE-STUDENT-FACE-");
	      executor.initialize();
	      return executor;
     }
	 
}
